function output = global_solve_upper(p,p_original,x,options,uppersolver)

% The bounds and relaxed solutions have been computed w.r.t to the relaxed
% bilinear model. We only need the original bounds and variables.
p.lb = p.lb(1:length(p_original.c));
p.ub = p.ub(1:length(p_original.c));
x = x(1:length(p_original.c));

if ~isempty(p.binary_variables)
    local_gave_good = find(abs(x(p.binary_variables)-fix(x(p.binary_variables)))<1e-3);
    p.lb(p.binary_variables(local_gave_good)) = fix(x(p.binary_variables(local_gave_good)));
    p.ub(p.binary_variables(local_gave_good)) = fix(x(p.binary_variables(local_gave_good)));
end

 if ~isempty(p.integer_variables)
     disp('FIX ME in global_solve_upper at 16')
%     local_gave_good = find(abs(x(p.integer_variables)-fix(x(p.integer_variables)))<1e-3);
%     p.lb((p.integer_variables(local_gave_good))) = fix(x(p.integer_variables(local_gave_good)));
%     p.ub((p.integer_variables(local_gave_good))) = fix(x(p.integer_variables(local_gave_good)));
 end
%         
p_upper = p_original;

p_upper.lb = p.lb;
p_upper.ub = p.ub;

% Pick an initial point (this can be a bit tricky...)
lbinfbounds = find(isinf(p.lb));
ubinfbounds = find(isinf(p.ub));
switch p.options.bmibnb.localstart
    case 'relaxed'
        p_upper.x0 = x;
        %if all(x<=p.ub) & all(x>=p.lb)
        %    p_upper.x0 = 0.1*x + 0.9*(p.lb+p.ub)/2;
        %else
        %    p_upper.x0 = (p.lb+p.ub)/2;
        %end
        % Shift towards interior for variables with unbounded lower or upper
 %       p_upper.x0(ubinfbounds) = x(ubinfbounds)+0.01;
 %       p_upper.x0(lbinfbounds) = x(lbinfbounds)-0.01;
        %ublbinfbounds = find(isinf(p.lb) & isinf(p.ub));
        %p_upper.x0(ublbinfbounds) = x(ublbinfbounds);
    case 'boxcenter'
        p_upper.x0 = x;        
        p_upper.x0(lbinfbounds)=0;
        p_upper.x0(ubinfbounds)=0;
    case 'zero'       
        p_upper.x0 = zeros(length(p.lb),1);
    otherwise
        error('Unknown local starting point option');
end

% Save time
p_upper.options.saveduals = 0;

% Solve upper bounding problem
p_upper.options.usex0 = 1;
output = feval(uppersolver,p_upper);

% Project into the box (numerical issue)
output.Primal(output.Primal<p_upper.lb) = p_upper.lb(output.Primal<p_upper.lb);
output.Primal(output.Primal>p_upper.ub) = p_upper.ub(output.Primal>p_upper.ub);


